=== debian/changelog ===
hol-light (1:3.0.0-2build7) plucky; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Mar 2025 18:43:55 +0100

hol-light (1:3.0.0-2build6) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 12 Feb 2025 21:36:10 +0100

hol-light (1:3.0.0-2build5) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jan 2025 22:22:22 +0100

hol-light (1:3.0.0-2build4) plucky; urgency=medium

  * Rebuild against latest camlp5

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 26 Jan 2025 16:39:33 -0500

hol-light (1:3.0.0-2build3) plucky; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 26 Jan 2025 09:09:29 +0100

hol-light (1:3.0.0-2build2) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Jan 2025 09:26:30 +0100

hol-light (1:3.0.0-2build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jan 2025 18:04:46 +0100

hol-light (1:3.0.0-2) unstable; urgency=medium

  * Team upload.
  * Remove libcoq-bignums on B-D from previous upload.

 -- Bo YU <tsu.yubo@gmail.com>  Sun, 15 Dec 2024 21:49:40 +0800

hol-light (1:3.0.0-1) unstable; urgency=medium

  * Team upload.
  * Enable d/watch
    - Clear some comments on d/watch
  * New upstream version 3.0.0. (Closes: #1073882)
  * Refresh d/patches/*
    - Drop 0004-Fix-build-with-camlp5-8.03.00.patch
    - Drop default-hollight-dir
  * Add libzarith-ocaml-dev and libcoq-bignums on B-D.
  * Use $(MAKE) to build it.
  * No need to install usr/share/hol-light/* explicitly.
  * Update d/copyright
  * Bump std-ver to 4.7.0
  * Add epoch to version number

 -- Bo YU <tsu.yubo@gmail.com>  Tue, 26 Nov 2024 12:34:41 +0800

hol-light (20231021-2) unstable; urgency=medium

  * Team upload
  * Fix build with camlp5 8.03.00

 -- Stéphane Glondu <glondu@debian.org>  Sun, 30 Jun 2024 10:31:46 +0200

hol-light (20231021-1) unstable; urgency=medium

  * Team upload
  * New upstream snapshot

 -- Stéphane Glondu <glondu@debian.org>  Mon, 23 Oct 2023 15:10:13 +0200

hol-light (20230128-2) unstable; urgency=medium

  * Team upload
  * Add support for camlp5 8.02
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Thu, 07 Sep 2023 03:44:32 +0200

hol-light (20230128-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * New upstream snapshot (Closes: #1002983)

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Use secure URI in Homepage field.
  * Bump debhelper from old 12 to 13.
    + Drop check for DEB_BUILD_OPTIONS containing "nocheck", since debhelper now
      does this.
    + debian/rules: Drop --fail-missing argument to dh_missing, which is now the
      default.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.0, no changes needed.

 -- Stéphane Glondu <glondu@debian.org>  Tue, 31 Jan 2023 12:10:03 +0100

hol-light (20190729-4) unstable; urgency=medium

  * Team upload
  * Fix compilation with camlp5 7.11

 -- Stéphane Glondu <glondu@debian.org>  Wed, 12 Feb 2020 05:43:48 +0100

hol-light (20190729-3) unstable; urgency=medium

  * Team upload
  * Add libnum-ocaml-dev to Build-Depends (Closes: #944277)
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.4.1
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Sun, 29 Dec 2019 13:24:09 +0100

hol-light (20190729-2) unstable; urgency=medium

  * Team upload.
  * Fix bad license in copyright file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Jul 2019 15:24:03 +0200

hol-light (20190729-1) unstable; urgency=medium

  * Team Upload
  * Cherry-pick changes from git:
    - add python runtime dependency
    - bump compat level to 10
    - README.debian: updated
    - udpate std-version to 4.4.0
  * Fix lintian warning about trailing whitespace
  * Fix lintian warning about not honouring nocheck test DH parameter
  * Fix lintian warning about deprecated extra priority.
  * update VCS fields to new location
  * remove trailing newlines
  * update changelog with missing changelog entry
  * Ack previous NMU

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Jul 2019 14:54:22 +0200

hol-light (20190729-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream snapshot (Closes: #876533)
    - Patch for new ocaml and camlp5
    - tweak rules file to stop copy of the new ml file
      This is already done in upstream build system.
    - do not install .pc file in the system (Closes: #878615)
  * Update copyright file
  * Update copyright file http in https mode

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 27 Jul 2019 10:19:28 +0200

hol-light (20171023-1) unstable; urgency=medium

  * Imported upstream version 20171023
    with git hash 39d9bf8b2958a288905661f969e9ab25b5ed74aa
  * delete camlp5-7 patch - was applied upstream; refresh other patches
  * compat level 10, standards version 4.1.1
  * update rules with new pa_j implementation (Closes: #876533)
  * minor change in control file - Flyspeck is completed
  * update copyright file
  * clear executable bit deletion in rules - has been fixed upstream
  * change to priority optional as demanded by lintian
  * suggests python as demanded by lintian
  * exclude .pc directory during installation (Closes: #878615)
  * README.Debian: hints on native toplevel and testsuite updates
  * delete some trailing whitespace for lintian

 -- Hendrik Tews <hendrik@askra.de>  Sun, 29 Oct 2017 20:55:28 +0100

hol-light (20170109-2) unstable; urgency=medium

  [ Hendrik Tews ]

