## hol-light 3.1.0

=== Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
        parser.ml printer.ml equal.ml bool.ml drule.ml tactics.ml        \
        itab.ml simp.ml theorems.ml ind_defs.ml class.ml trivia.ml       \
        canon.ml meson.ml firstorder.ml metis.ml thecops.ml quot.ml      \
-       impconv.ml recursion.ml pair.ml                                  \
+       impconv.ml recursion.ml pair.ml compute.ml                       \
        nums.ml arith.ml wf.ml calc_num.ml normalizer.ml grobner.ml      \
        ind_types.ml lists.ml realax.ml calc_int.ml realarith.ml         \
        real.ml calc_rat.ml int.ml sets.ml iterate.ml cart.ml define.ml  \
@@ -135,7 +135,7 @@
 hol_loader.cmx: hol_loader.ml ; \
         ocamlopt -verbose -c hol_loader.ml -o hol_loader.cmx
 
-hol_lib_inlined.ml: hol_lib.ml inline_load.ml ; \
+hol_lib_inlined.ml: ${HOLSRC} inline_load.ml ; \
         HOLLIGHT_DIR="`pwd`" ocaml inline_load.ml hol_lib.ml hol_lib_inlined.ml -omit-prelude
 
 hol_lib.cmo: pa_j.cmo hol_lib_inlined.ml hol_loader.cmo bignum.cmo ; \
@@ -185,23 +185,20 @@
 default: hol_lib.cma hol_lib.cmxa unit_tests.byte unit_tests.native
 endif
 
-# TODO: update this and hol.* commands to use one of checkpointing  tools
-# other than ckpt.
-# Build a standalone hol image called "hol" (needs Linux and ckpt program)
-
-hol: pa_j.cmo ${HOLSRC} update_database.ml;                    \
+# Build a standalone hol image called "hol" (needs Linux and DMTCP)
+
+hol: hol.sh make-checkpoint.sh update_database.ml;                      \
      if test `uname` = Linux; then                                      \
-     echo -e '#use "make.ml";;\nloadt "update_database.ml";;\nself_destruct "";;' | ckpt -a SIGUSR1 -n hol.snapshot ocaml;\
-     mv hol.snapshot hol;                                               \
+     ./make-checkpoint.sh hol "loadt \"update_database.ml\"" ;          \
      else                                                               \
      echo '******************************************************';     \
-     echo 'FAILURE: Image build assumes Linux and ckpt program';        \
+     echo 'FAILURE: Image build assumes Linux and DMTCP';               \
      echo '******************************************************';     \
      fi
 
 # Build an image with multivariate calculus preloaded.
 
-hol.multivariate: ./hol                                                 \
+hol.multivariate: hol.sh make-checkpoint.sh Multivariate/make.ml        \
      Library/card.ml Library/permutations.ml Library/products.ml        \
      Library/floor.ml Multivariate/misc.ml Library/iter.ml              \
      Multivariate/metric.ml Multivariate/vectors.ml                     \
@@ -211,10 +208,14 @@
      Multivariate/derivatives.ml Multivariate/clifford.ml               \
      Multivariate/integration.ml Multivariate/measure.ml                \
      Multivariate/multivariate_database.ml update_database.ml;          \
-     echo -e 'loadt "Multivariate/make.ml";;\nloadt "update_database.ml";;\nself_destruct "Preloaded with multivariate analysis";;' | ./hol; mv hol.snapshot hol.multivariate;
+     if test `uname` = Linux; then                                      \
+     ./make-checkpoint.sh hol.multivariate "loadt \"Multivariate/make.ml\"; loadt \"update_database.ml\""; \
+     else                                                               \
+     echo '******************************************************';     \
+     echo 'FAILURE: Image build assumes Linux and DMTCP';               \
+     echo '******************************************************';     \
+     fi
 
 # Build an image with analysis and SOS procedure preloaded
 
-hol.sosa: ./hol                                                         \
-     Library/analysis.ml Library/transc.ml                              \
-     Examples/sos.ml update_database.ml;                                \
+hol.sosa: hol.sh make-checkpoint.sh                                     \
