=== debian/changelog ===
hol-light (1:3.1.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Switch debian/watch to version 5
  * Bump Standards-Version to 4.7.2
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Sat, 20 Dec 2025 03:58:13 +0100
