=== debian/control ===
--- 
+++ 
@@ -12,8 +12,7 @@
  ocaml-findlib,
  dh-ocaml,
  libzarith-ocaml-dev,
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://www.cl.cam.ac.uk/~jrh13/hol-light/
 Vcs-Git: https://salsa.debian.org/ocaml-team/hol-light.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/hol-light
