=== debian/watch ===
Version: 5

Source: https://github.com/jrh13/hol-light/releases
Matching-Pattern: releases/tag/(?:Release|v)@ANY_VERSION@
Downloadurlmangle: s|releases/tag|archive/refs/tags|;s|$|.zip|
Dversionmangle: auto
Repacksuffix: +dfsg
